const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    enabled,
    delete: _delete
};

/**
 * Format an array of employeeStatuses by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} employeeStatuses - The array of employeeStatuses to format.
 * @returns {Promise<Object[]>} - The formatted array of employeeStatuses.
 */
const formatWithModifier = async (employeeStatuses) => {
    return Promise.all(
        employeeStatuses.map(async (employeeStatus) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: employeeStatus.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...employeeStatus,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Get all employeeStatuses with their respective companies.
 * @param {Object} params - An object that contains parameters to filter the employeeStatuses.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the employeeStatuses and a success flag.
 * @example
 * const result = await getAll({ companiesId: [1, 2] });
 * console.log(result);
 */
async function getAll(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        let employeeStatuses = [];
        employeeStatuses = await dbSAPPS.EmployeeStatus.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'display_name']
                }
            ]
        });

        employeeStatuses = employeeStatuses.map(employeeStatus => {
            return {
                ...employeeStatus.dataValues,
                company_name: employeeStatus?.company?.display_name
            }
        });

        employeeStatuses = await formatWithModifier(employeeStatuses);

        return {
            employeeStatuses,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage,
        };
    }
}

/**
 * Get employeeStatuses with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the employeeStatuses.
 * @param {Array} params.companiesId - Array of company IDs to filter by.
 * @returns {Promise<Object>} Resolves with an object that contains the employeeStatuses and a success flag.
 * @example
 * const result = await option({ companiesId: [1, 2] });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        if (params.companiesId) {
            filterConditions.company_id = {
                [Op.in]: params.companiesId
            };
        }

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        let options = [];
        options = await dbSAPPS.EmployeeStatus.findAll({
            where: filterConditions,
            attributes: ['id', 'name', 'display_name'],
            include: [
                {
                    model: dbSAPPS.Company,
                    as: 'company',
                    attributes: ['id', 'name', 'display_name']
                }
            ],
            order: [['name', 'ASC']]
        });

        options = options.map(option => {
            return {
                ...option.dataValues,
                company_name: option?.company?.display_name
            }
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active employeeStatuses
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */
async function count(params) {
    try {
        // filter
        const filterConditions = {};

        // must be enabled
        filterConditions.enabled = {
            [Op.eq]: true
        };

        const count = await dbSAPPS.EmployeeStatus.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new employeeStatus
 * 
 * @param {object} params - employeeStatus data to be created.
 * @param {string} params.name - employeeStatus name.
 * @param {string} params.display_name - employeeStatus display name.
 * @param {boolean} [params.enabled=true] - employeeStatus enabled status.
 * @param {number} [params.creation=Date.now()] - employeeStatus creation timestamp.
 * @param {number} [params.modified=Date.now()] - employeeStatus last modification timestamp.
 * @param {number} [params.owner=1] - User ID of the employeeStatus owner.
 * @param {number} [params.modified_by=1] - User ID of the last modifier of the employeeStatus.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the employeeStatus creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingName = await dbSAPPS.EmployeeStatus.findOne({
            where: { name: params.name, company_id: params.company_id },
            transaction
        });
        if (existingName) {
            return {
                success: false,
                message: `"${params.name}" is already taken.`
            };
        }

        const existingDisplayName = await dbSAPPS.EmployeeStatus.findOne({
            where: { display_name: params.display_name, company_id: params.company_id },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.EmployeeStatus.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing employeeStatus
 * 
 * @param {number} id - employeeStatus ID to be updated.
 * @param {object} params - employeeStatus data to be updated.
 * @param {string} [params.name] - employeeStatus name.
 * @param {string} [params.display_name] - employeeStatus display name.
 * @param {boolean} [params.enabled] - employeeStatus enabled status.
 * @param {number} [params.creation] - employeeStatus creation timestamp.
 * @param {number} [params.modified] - employeeStatus last modification timestamp.
 * @param {number} [params.owner] - User ID of the employeeStatus owner.
 * @param {number} [params.modified_by] - User ID of the last modifier of the employeeStatus.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the employeeStatus update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const employeeStatus = await dbSAPPS.EmployeeStatus.findByPk(id);
        if (!employeeStatus) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingName = await dbSAPPS.EmployeeStatus.findOne({
            where: {
                name: params.name,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingName) {
            return {
                success: false,
                message: `"${params.name}" is already taken.`
            };
        }

        const existingDisplayName = await dbSAPPS.EmployeeStatus.findOne({
            where: {
                display_name: params.display_name,
                company_id: params.company_id,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await employeeStatus.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Enable or disable a employeeStatus
 * @param {number} id - the id of the employeeStatus
 * @param {object} params - the update data
 * @param {boolean} params.enabled - the enabled status of the employeeStatus
 * @param {number} [params.modified_by] - the modified by of the employeeStatus
 * @param {Date} [params.modified] - the modified of the employeeStatus
 * @returns {Promise<object>} - the result of the update
 */
async function enabled(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const employeeStatus = await dbSAPPS.EmployeeStatus.findByPk(id);
        if (!employeeStatus) return { success: false, message: 'ID not found!' };

        // update params
        const updateData = {};
        updateData.enabled = params.enabled;
        if (params.modified_by) updateData.modified_by = params.modified_by;
        if (params.modified) updateData.modified = params.modified;

        // save
        await employeeStatus.update(updateData, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a employeeStatus
 * @param {number} id - the id of the employeeStatus
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const employeeStatus = await dbSAPPS.EmployeeStatus.findByPk(id, { transaction });
        if (!employeeStatus) return { success: false, message: 'ID not found!' };

        // delete
        await employeeStatus.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
